Index: lemon/dfs.h
===================================================================
--- lemon/dfs.h	(revision 327)
+++ lemon/dfs.h	(revision 220)
@@ -22,5 +22,5 @@
 ///\ingroup search
 ///\file
-///\brief DFS algorithm.
+///\brief Dfs algorithm.
 
 #include <lemon/list_graph.h>
@@ -29,7 +29,9 @@
 #include <lemon/error.h>
 #include <lemon/maps.h>
-#include <lemon/path.h>
+
+#include <lemon/concept_check.h>
 
 namespace lemon {
+
 
   ///Default traits class of Dfs class.
@@ -40,22 +42,22 @@
   struct DfsDefaultTraits
   {
-    ///The type of the digraph the algorithm runs on.
+    ///The digraph type the algorithm runs on.
     typedef GR Digraph;
-
-    ///\brief The type of the map that stores the predecessor
+    ///\brief The type of the map that stores the last
     ///arcs of the %DFS paths.
     ///
-    ///The type of the map that stores the predecessor
+    ///The type of the map that stores the last
     ///arcs of the %DFS paths.
     ///It must meet the \ref concepts::WriteMap "WriteMap" concept.
-    typedef typename Digraph::template NodeMap<typename Digraph::Arc> PredMap;
+    ///
+    typedef typename Digraph::template NodeMap<typename GR::Arc> PredMap;
     ///Instantiates a PredMap.
 
-    ///This function instantiates a PredMap.
-    ///\param g is the digraph, to which we would like to define the
-    ///PredMap.
-    static PredMap *createPredMap(const Digraph &g)
-    {
-      return new PredMap(g);
+    ///This function instantiates a \ref PredMap.
+    ///\param G is the digraph, to which we would like to define the PredMap.
+    ///\todo The digraph alone may be insufficient to initialize
+    static PredMap *createPredMap(const GR &G)
+    {
+      return new PredMap(G);
     }
 
@@ -64,47 +66,48 @@
     ///The type of the map that indicates which nodes are processed.
     ///It must meet the \ref concepts::WriteMap "WriteMap" concept.
+    ///\todo named parameter to set this type, function to read and write.
     typedef NullMap<typename Digraph::Node,bool> ProcessedMap;
     ///Instantiates a ProcessedMap.
 
-    ///This function instantiates a ProcessedMap.
+    ///This function instantiates a \ref ProcessedMap.
     ///\param g is the digraph, to which
-    ///we would like to define the ProcessedMap
+    ///we would like to define the \ref ProcessedMap
 #ifdef DOXYGEN
-    static ProcessedMap *createProcessedMap(const Digraph &g)
+    static ProcessedMap *createProcessedMap(const GR &g)
 #else
-    static ProcessedMap *createProcessedMap(const Digraph &)
+    static ProcessedMap *createProcessedMap(const GR &)
 #endif
     {
       return new ProcessedMap();
     }
-
     ///The type of the map that indicates which nodes are reached.
 
     ///The type of the map that indicates which nodes are reached.
-    ///It must meet the \ref concepts::ReadWriteMap "ReadWriteMap" concept.
+    ///It must meet the \ref concepts::WriteMap "WriteMap" concept.
+    ///\todo named parameter to set this type, function to read and write.
     typedef typename Digraph::template NodeMap<bool> ReachedMap;
     ///Instantiates a ReachedMap.
 
-    ///This function instantiates a ReachedMap.
-    ///\param g is the digraph, to which
-    ///we would like to define the ReachedMap.
-    static ReachedMap *createReachedMap(const Digraph &g)
-    {
-      return new ReachedMap(g);
-    }
-
-    ///The type of the map that stores the distances of the nodes.
-
-    ///The type of the map that stores the distances of the nodes.
+    ///This function instantiates a \ref ReachedMap.
+    ///\param G is the digraph, to which
+    ///we would like to define the \ref ReachedMap.
+    static ReachedMap *createReachedMap(const GR &G)
+    {
+      return new ReachedMap(G);
+    }
+    ///The type of the map that stores the dists of the nodes.
+
+    ///The type of the map that stores the dists of the nodes.
     ///It must meet the \ref concepts::WriteMap "WriteMap" concept.
+    ///
     typedef typename Digraph::template NodeMap<int> DistMap;
     ///Instantiates a DistMap.
 
-    ///This function instantiates a DistMap.
-    ///\param g is the digraph, to which we would like to define the
-    ///DistMap.
-    static DistMap *createDistMap(const Digraph &g)
-    {
-      return new DistMap(g);
+    ///This function instantiates a \ref DistMap.
+    ///\param G is the digraph, to which we would like to define
+    ///the \ref DistMap
+    static DistMap *createDistMap(const GR &G)
+    {
+      return new DistMap(G);
     }
   };
@@ -115,11 +118,7 @@
   ///This class provides an efficient implementation of the %DFS algorithm.
   ///
-  ///There is also a \ref dfs() "function-type interface" for the DFS
-  ///algorithm, which is convenient in the simplier cases and it can be
-  ///used easier.
-  ///
-  ///\tparam GR The type of the digraph the algorithm runs on.
-  ///The default value is \ref ListDigraph. The value of GR is not used
-  ///directly by \ref Dfs, it is only passed to \ref DfsDefaultTraits.
+  ///\tparam GR The digraph type the algorithm runs on. The default value is
+  ///\ref ListDigraph. The value of GR is not used directly by Dfs, it
+  ///is only passed to \ref DfsDefaultTraits.
   ///\tparam TR Traits class to set various data types used by the algorithm.
   ///The default traits class is
@@ -136,47 +135,56 @@
   class Dfs {
   public:
-
-    ///The type of the digraph the algorithm runs on.
+    /**
+     * \brief \ref Exception for uninitialized parameters.
+     *
+     * This error represents problems in the initialization
+     * of the parameters of the algorithms.
+     */
+    class UninitializedParameter : public lemon::UninitializedParameter {
+    public:
+      virtual const char* what() const throw() {
+        return "lemon::Dfs::UninitializedParameter";
+      }
+    };
+
+    typedef TR Traits;
+    ///The type of the underlying digraph.
     typedef typename TR::Digraph Digraph;
-
-    ///\brief The type of the map that stores the predecessor arcs of the
-    ///DFS paths.
+    ///\e
+    typedef typename Digraph::Node Node;
+    ///\e
+    typedef typename Digraph::NodeIt NodeIt;
+    ///\e
+    typedef typename Digraph::Arc Arc;
+    ///\e
+    typedef typename Digraph::OutArcIt OutArcIt;
+
+    ///\brief The type of the map that stores the last
+    ///arcs of the %DFS paths.
     typedef typename TR::PredMap PredMap;
-    ///The type of the map that stores the distances of the nodes.
+    ///The type of the map indicating which nodes are reached.
+    typedef typename TR::ReachedMap ReachedMap;
+    ///The type of the map indicating which nodes are processed.
+    typedef typename TR::ProcessedMap ProcessedMap;
+    ///The type of the map that stores the dists of the nodes.
     typedef typename TR::DistMap DistMap;
-    ///The type of the map that indicates which nodes are reached.
-    typedef typename TR::ReachedMap ReachedMap;
-    ///The type of the map that indicates which nodes are processed.
-    typedef typename TR::ProcessedMap ProcessedMap;
-    ///The type of the paths.
-    typedef PredMapPath<Digraph, PredMap> Path;
-
-    ///The traits class.
-    typedef TR Traits;
-
   private:
-
-    typedef typename Digraph::Node Node;
-    typedef typename Digraph::NodeIt NodeIt;
-    typedef typename Digraph::Arc Arc;
-    typedef typename Digraph::OutArcIt OutArcIt;
-
-    //Pointer to the underlying digraph.
+    /// Pointer to the underlying digraph.
     const Digraph *G;
-    //Pointer to the map of predecessor arcs.
+    ///Pointer to the map of predecessors arcs.
     PredMap *_pred;
-    //Indicates if _pred is locally allocated (true) or not.
+    ///Indicates if \ref _pred is locally allocated (\c true) or not.
     bool local_pred;
-    //Pointer to the map of distances.
+    ///Pointer to the map of distances.
     DistMap *_dist;
-    //Indicates if _dist is locally allocated (true) or not.
+    ///Indicates if \ref _dist is locally allocated (\c true) or not.
     bool local_dist;
-    //Pointer to the map of reached status of the nodes.
+    ///Pointer to the map of reached status of the nodes.
     ReachedMap *_reached;
-    //Indicates if _reached is locally allocated (true) or not.
+    ///Indicates if \ref _reached is locally allocated (\c true) or not.
     bool local_reached;
-    //Pointer to the map of processed status of the nodes.
+    ///Pointer to the map of processed status of the nodes.
     ProcessedMap *_processed;
-    //Indicates if _processed is locally allocated (true) or not.
+    ///Indicates if \ref _processed is locally allocated (\c true) or not.
     bool local_processed;
 
@@ -184,5 +192,7 @@
     int _stack_head;
 
-    //Creates the maps if necessary.
+    ///Creates the maps if necessary.
+
+    ///\todo Better memory allocation (instead of new).
     void create_maps()
     {
@@ -218,95 +228,93 @@
 
     template <class T>
-    struct SetPredMapTraits : public Traits {
+    struct DefPredMapTraits : public Traits {
       typedef T PredMap;
-      static PredMap *createPredMap(const Digraph &)
+      static PredMap *createPredMap(const Digraph &G)
       {
-        LEMON_ASSERT(false, "PredMap is not initialized");
-        return 0; // ignore warnings
+        throw UninitializedParameter();
       }
     };
     ///\brief \ref named-templ-param "Named parameter" for setting
-    ///PredMap type.
-    ///
-    ///\ref named-templ-param "Named parameter" for setting
-    ///PredMap type.
+    ///PredMap type
+    ///
+    ///\ref named-templ-param "Named parameter" for setting PredMap type
+    ///
     template <class T>
-    struct SetPredMap : public Dfs<Digraph, SetPredMapTraits<T> > {
-      typedef Dfs<Digraph, SetPredMapTraits<T> > Create;
-    };
+    struct DefPredMap : public Dfs<Digraph, DefPredMapTraits<T> > {
+      typedef Dfs<Digraph, DefPredMapTraits<T> > Create;
+    };
+
 
     template <class T>
-    struct SetDistMapTraits : public Traits {
+    struct DefDistMapTraits : public Traits {
       typedef T DistMap;
       static DistMap *createDistMap(const Digraph &)
       {
-        LEMON_ASSERT(false, "DistMap is not initialized");
-        return 0; // ignore warnings
+        throw UninitializedParameter();
       }
     };
     ///\brief \ref named-templ-param "Named parameter" for setting
-    ///DistMap type.
-    ///
-    ///\ref named-templ-param "Named parameter" for setting
-    ///DistMap type.
+    ///DistMap type
+    ///
+    ///\ref named-templ-param "Named parameter" for setting DistMap
+    ///type
     template <class T>
-    struct SetDistMap : public Dfs< Digraph, SetDistMapTraits<T> > {
-      typedef Dfs<Digraph, SetDistMapTraits<T> > Create;
+    struct DefDistMap {
+      typedef Dfs<Digraph, DefDistMapTraits<T> > Create;
     };
 
     template <class T>
-    struct SetReachedMapTraits : public Traits {
+    struct DefReachedMapTraits : public Traits {
       typedef T ReachedMap;
       static ReachedMap *createReachedMap(const Digraph &)
       {
-        LEMON_ASSERT(false, "ReachedMap is not initialized");
-        return 0; // ignore warnings
+        throw UninitializedParameter();
       }
     };
     ///\brief \ref named-templ-param "Named parameter" for setting
-    ///ReachedMap type.
-    ///
-    ///\ref named-templ-param "Named parameter" for setting
-    ///ReachedMap type.
+    ///ReachedMap type
+    ///
+    ///\ref named-templ-param "Named parameter" for setting ReachedMap type
+    ///
     template <class T>
-    struct SetReachedMap : public Dfs< Digraph, SetReachedMapTraits<T> > {
-      typedef Dfs< Digraph, SetReachedMapTraits<T> > Create;
+    struct DefReachedMap : public Dfs< Digraph, DefReachedMapTraits<T> > {
+      typedef Dfs< Digraph, DefReachedMapTraits<T> > Create;
     };
 
     template <class T>
-    struct SetProcessedMapTraits : public Traits {
+    struct DefProcessedMapTraits : public Traits {
       typedef T ProcessedMap;
       static ProcessedMap *createProcessedMap(const Digraph &)
       {
-        LEMON_ASSERT(false, "ProcessedMap is not initialized");
-        return 0; // ignore warnings
+        throw UninitializedParameter();
       }
     };
     ///\brief \ref named-templ-param "Named parameter" for setting
-    ///ProcessedMap type.
-    ///
-    ///\ref named-templ-param "Named parameter" for setting
-    ///ProcessedMap type.
+    ///ProcessedMap type
+    ///
+    ///\ref named-templ-param "Named parameter" for setting ProcessedMap type
+    ///
     template <class T>
-    struct SetProcessedMap : public Dfs< Digraph, SetProcessedMapTraits<T> > {
-      typedef Dfs< Digraph, SetProcessedMapTraits<T> > Create;
-    };
-
-    struct SetStandardProcessedMapTraits : public Traits {
+    struct DefProcessedMap : public Dfs< Digraph, DefProcessedMapTraits<T> > {
+      typedef Dfs< Digraph, DefProcessedMapTraits<T> > Create;
+    };
+
+    struct DefDigraphProcessedMapTraits : public Traits {
       typedef typename Digraph::template NodeMap<bool> ProcessedMap;
-      static ProcessedMap *createProcessedMap(const Digraph &g)
+      static ProcessedMap *createProcessedMap(const Digraph &G)
       {
-        return new ProcessedMap(g);
-      }
-    };
-    ///\brief \ref named-templ-param "Named parameter" for setting
-    ///ProcessedMap type to be <tt>Digraph::NodeMap<bool></tt>.
-    ///
-    ///\ref named-templ-param "Named parameter" for setting
-    ///ProcessedMap type to be <tt>Digraph::NodeMap<bool></tt>.
-    ///If you don't set it explicitly, it will be automatically allocated.
-    struct SetStandardProcessedMap :
-      public Dfs< Digraph, SetStandardProcessedMapTraits > {
-      typedef Dfs< Digraph, SetStandardProcessedMapTraits > Create;
+        return new ProcessedMap(G);
+      }
+    };
+    ///\brief \ref named-templ-param "Named parameter"
+    ///for setting the ProcessedMap type to be Digraph::NodeMap<bool>.
+    ///
+    ///\ref named-templ-param "Named parameter"
+    ///for setting the ProcessedMap type to be Digraph::NodeMap<bool>.
+    ///If you don't set it explicitely, it will be automatically allocated.
+    template <class T>
+    class DefProcessedMapToBeDefaultMap :
+      public Dfs< Digraph, DefDigraphProcessedMapTraits> {
+      typedef Dfs< Digraph, DefDigraphProcessedMapTraits> Create;
     };
 
@@ -317,8 +325,8 @@
     ///Constructor.
 
-    ///Constructor.
-    ///\param g The digraph the algorithm runs on.
-    Dfs(const Digraph &g) :
-      G(&g),
+    ///\param _G the digraph the algorithm will run on.
+    ///
+    Dfs(const Digraph& _G) :
+      G(&_G),
       _pred(NULL), local_pred(false),
       _dist(NULL), local_dist(false),
@@ -336,9 +344,9 @@
     }
 
-    ///Sets the map that stores the predecessor arcs.
-
-    ///Sets the map that stores the predecessor arcs.
+    ///Sets the map storing the predecessor arcs.
+
+    ///Sets the map storing the predecessor arcs.
     ///If you don't use this function before calling \ref run(),
-    ///it will allocate one. The destructor deallocates this
+    ///it will allocate one. The destuctor deallocates this
     ///automatically allocated map, of course.
     ///\return <tt> (*this) </tt>
@@ -353,9 +361,26 @@
     }
 
-    ///Sets the map that indicates which nodes are reached.
-
-    ///Sets the map that indicates which nodes are reached.
+    ///Sets the map storing the distances calculated by the algorithm.
+
+    ///Sets the map storing the distances calculated by the algorithm.
     ///If you don't use this function before calling \ref run(),
-    ///it will allocate one. The destructor deallocates this
+    ///it will allocate one. The destuctor deallocates this
+    ///automatically allocated map, of course.
+    ///\return <tt> (*this) </tt>
+    Dfs &distMap(DistMap &m)
+    {
+      if(local_dist) {
+        delete _dist;
+        local_dist=false;
+      }
+      _dist = &m;
+      return *this;
+    }
+
+    ///Sets the map indicating if a node is reached.
+
+    ///Sets the map indicating if a node is reached.
+    ///If you don't use this function before calling \ref run(),
+    ///it will allocate one. The destuctor deallocates this
     ///automatically allocated map, of course.
     ///\return <tt> (*this) </tt>
@@ -370,9 +395,9 @@
     }
 
-    ///Sets the map that indicates which nodes are processed.
-
-    ///Sets the map that indicates which nodes are processed.
+    ///Sets the map indicating if a node is processed.
+
+    ///Sets the map indicating if a node is processed.
     ///If you don't use this function before calling \ref run(),
-    ///it will allocate one. The destructor deallocates this
+    ///it will allocate one. The destuctor deallocates this
     ///automatically allocated map, of course.
     ///\return <tt> (*this) </tt>
@@ -387,33 +412,14 @@
     }
 
-    ///Sets the map that stores the distances of the nodes.
-
-    ///Sets the map that stores the distances of the nodes calculated by
-    ///the algorithm.
-    ///If you don't use this function before calling \ref run(),
-    ///it will allocate one. The destructor deallocates this
-    ///automatically allocated map, of course.
-    ///\return <tt> (*this) </tt>
-    Dfs &distMap(DistMap &m)
-    {
-      if(local_dist) {
-        delete _dist;
-        local_dist=false;
-      }
-      _dist = &m;
-      return *this;
-    }
-
   public:
-
     ///\name Execution control
     ///The simplest way to execute the algorithm is to use
-    ///one of the member functions called \ref lemon::Dfs::run() "run()".
+    ///one of the member functions called \c run(...).
     ///\n
-    ///If you need more control on the execution, first you must call
-    ///\ref lemon::Dfs::init() "init()", then you can add a source node
-    ///with \ref lemon::Dfs::addSource() "addSource()".
-    ///Finally \ref lemon::Dfs::start() "start()" will perform the
-    ///actual path computation.
+    ///If you need more control on the execution,
+    ///first you must call \ref init(), then you can add a source node
+    ///with \ref addSource().
+    ///Finally \ref start() will perform the actual path
+    ///computation.
 
     ///@{
@@ -430,4 +436,5 @@
       for ( NodeIt u(*G) ; u!=INVALID ; ++u ) {
         _pred->set(u,INVALID);
+        // _predNode->set(u,INVALID);
         _reached->set(u,false);
         _processed->set(u,false);
@@ -439,12 +446,8 @@
     ///Adds a new source node to the set of nodes to be processed.
     ///
-    ///\pre The stack must be empty. (Otherwise the algorithm gives
-    ///false results.)
-    ///
-    ///\warning Distances will be wrong (or at least strange) in case of
-    ///multiple sources.
+    ///\warning dists are wrong (or at least strange)
+    ///in case of multiple sources.
     void addSource(Node s)
     {
-      LEMON_DEBUG(emptyQueue(), "The stack is not empty.");
       if(!(*_reached)[s])
         {
@@ -469,5 +472,5 @@
     ///\return The processed arc.
     ///
-    ///\pre The stack must not be empty.
+    ///\pre The stack must not be empty!
     Arc processNextArc()
     {
@@ -495,12 +498,11 @@
       return e;
     }
-
     ///Next arc to be processed.
 
     ///Next arc to be processed.
     ///
-    ///\return The next arc to be processed or \c INVALID if the stack
-    ///is empty.
-    OutArcIt nextArc() const
+    ///\return The next arc to be processed or INVALID if the stack is
+    /// empty.
+    OutArcIt nextArc()
     {
       return _stack_head>=0?_stack[_stack_head]:INVALID;
@@ -508,14 +510,13 @@
 
     ///\brief Returns \c false if there are nodes
-    ///to be processed.
+    ///to be processed in the queue
     ///
     ///Returns \c false if there are nodes
-    ///to be processed in the queue (stack).
-    bool emptyQueue() const { return _stack_head<0; }
-
+    ///to be processed in the queue
+    bool emptyQueue() { return _stack_head<0; }
     ///Returns the number of the nodes to be processed.
 
-    ///Returns the number of the nodes to be processed in the queue (stack).
-    int queueSize() const { return _stack_head+1; }
+    ///Returns the number of the nodes to be processed in the queue.
+    int queueSize() { return _stack_head+1; }
 
     ///Executes the algorithm.
@@ -523,20 +524,14 @@
     ///Executes the algorithm.
     ///
-    ///This method runs the %DFS algorithm from the root node
-    ///in order to compute the DFS path to each node.
-    ///
-    /// The algorithm computes
-    ///- the %DFS tree,
-    ///- the distance of each node from the root in the %DFS tree.
-    ///
-    ///\pre init() must be called and a root node should be
-    ///added with addSource() before using this function.
-    ///
-    ///\note <tt>d.start()</tt> is just a shortcut of the following code.
-    ///\code
-    ///  while ( !d.emptyQueue() ) {
-    ///    d.processNextArc();
-    ///  }
-    ///\endcode
+    ///\pre init() must be called and at least one node should be added
+    ///with addSource() before using this function.
+    ///
+    ///This method runs the %DFS algorithm from the root node(s)
+    ///in order to
+    ///compute the
+    ///%DFS path to each node. The algorithm computes
+    ///- The %DFS tree.
+    ///- The distance of each node from the root(s) in the %DFS tree.
+    ///
     void start()
     {
@@ -544,20 +539,21 @@
     }
 
-    ///Executes the algorithm until the given target node is reached.
-
-    ///Executes the algorithm until the given target node is reached.
-    ///
-    ///This method runs the %DFS algorithm from the root node
-    ///in order to compute the DFS path to \c t.
-    ///
-    ///The algorithm computes
-    ///- the %DFS path to \c t,
-    ///- the distance of \c t from the root in the %DFS tree.
-    ///
-    ///\pre init() must be called and a root node should be
-    ///added with addSource() before using this function.
-    void start(Node t)
-    {
-      while ( !emptyQueue() && G->target(_stack[_stack_head])!=t )
+    ///Executes the algorithm until \c dest is reached.
+
+    ///Executes the algorithm until \c dest is reached.
+    ///
+    ///\pre init() must be called and at least one node should be added
+    ///with addSource() before using this function.
+    ///
+    ///This method runs the %DFS algorithm from the root node(s)
+    ///in order to
+    ///compute the
+    ///%DFS path to \c dest. The algorithm computes
+    ///- The %DFS path to \c  dest.
+    ///- The distance of \c dest from the root(s) in the %DFS tree.
+    ///
+    void start(Node dest)
+    {
+      while ( !emptyQueue() && G->target(_stack[_stack_head])!=dest )
         processNextArc();
     }
@@ -567,84 +563,37 @@
     ///Executes the algorithm until a condition is met.
     ///
-    ///This method runs the %DFS algorithm from the root node
-    ///until an arc \c a with <tt>am[a]</tt> true is found.
-    ///
-    ///\param am A \c bool (or convertible) arc map. The algorithm
-    ///will stop when it reaches an arc \c a with <tt>am[a]</tt> true.
-    ///
-    ///\return The reached arc \c a with <tt>am[a]</tt> true or
+    ///\pre init() must be called and at least one node should be added
+    ///with addSource() before using this function.
+    ///
+    ///\param em must be a bool (or convertible) arc map. The algorithm
+    ///will stop when it reaches an arc \c e with <tt>em[e]</tt> true.
+    ///
+    ///\return The reached arc \c e with <tt>em[e]</tt> true or
     ///\c INVALID if no such arc was found.
     ///
-    ///\pre init() must be called and a root node should be
-    ///added with addSource() before using this function.
-    ///
-    ///\warning Contrary to \ref Bfs and \ref Dijkstra, \c am is an arc map,
+    ///\warning Contrary to \ref Bfs and \ref Dijkstra, \c em is an arc map,
     ///not a node map.
-    template<class ArcBoolMap>
-    Arc start(const ArcBoolMap &am)
-    {
-      while ( !emptyQueue() && !am[_stack[_stack_head]] )
+    template<class EM>
+    Arc start(const EM &em)
+    {
+      while ( !emptyQueue() && !em[_stack[_stack_head]] )
         processNextArc();
       return emptyQueue() ? INVALID : _stack[_stack_head];
     }
 
-    ///Runs the algorithm from the given source node.
-
-    ///This method runs the %DFS algorithm from node \c s
-    ///in order to compute the DFS path to each node.
-    ///
-    ///The algorithm computes
-    ///- the %DFS tree,
-    ///- the distance of each node from the root in the %DFS tree.
-    ///
-    ///\note <tt>d.run(s)</tt> is just a shortcut of the following code.
+    ///Runs %DFS algorithm to visit all nodes in the digraph.
+
+    ///This method runs the %DFS algorithm in order to
+    ///compute the
+    ///%DFS path to each node. The algorithm computes
+    ///- The %DFS tree.
+    ///- The distance of each node from the root in the %DFS tree.
+    ///
+    ///\note d.run() is just a shortcut of the following code.
     ///\code
     ///  d.init();
-    ///  d.addSource(s);
-    ///  d.start();
-    ///\endcode
-    void run(Node s) {
-      init();
-      addSource(s);
-      start();
-    }
-
-    ///Finds the %DFS path between \c s and \c t.
-
-    ///This method runs the %DFS algorithm from node \c s
-    ///in order to compute the DFS path to node \c t
-    ///(it stops searching when \c t is processed)
-    ///
-    ///\return \c true if \c t is reachable form \c s.
-    ///
-    ///\note Apart from the return value, <tt>d.run(s,t)</tt> is
-    ///just a shortcut of the following code.
-    ///\code
-    ///  d.init();
-    ///  d.addSource(s);
-    ///  d.start(t);
-    ///\endcode
-    bool run(Node s,Node t) {
-      init();
-      addSource(s);
-      start(t);
-      return reached(t);
-    }
-
-    ///Runs the algorithm to visit all nodes in the digraph.
-
-    ///This method runs the %DFS algorithm in order to compute the
-    ///%DFS path to each node.
-    ///
-    ///The algorithm computes
-    ///- the %DFS tree,
-    ///- the distance of each node from the root in the %DFS tree.
-    ///
-    ///\note <tt>d.run()</tt> is just a shortcut of the following code.
-    ///\code
-    ///  d.init();
-    ///  for (NodeIt n(digraph); n != INVALID; ++n) {
-    ///    if (!d.reached(n)) {
-    ///      d.addSource(n);
+    ///  for (NodeIt it(digraph); it != INVALID; ++it) {
+    ///    if (!d.reached(it)) {
+    ///      d.addSource(it);
     ///      d.start();
     ///    }
@@ -661,4 +610,45 @@
     }
 
+    ///Runs %DFS algorithm from node \c s.
+
+    ///This method runs the %DFS algorithm from a root node \c s
+    ///in order to
+    ///compute the
+    ///%DFS path to each node. The algorithm computes
+    ///- The %DFS tree.
+    ///- The distance of each node from the root in the %DFS tree.
+    ///
+    ///\note d.run(s) is just a shortcut of the following code.
+    ///\code
+    ///  d.init();
+    ///  d.addSource(s);
+    ///  d.start();
+    ///\endcode
+    void run(Node s) {
+      init();
+      addSource(s);
+      start();
+    }
+
+    ///Finds the %DFS path between \c s and \c t.
+
+    ///Finds the %DFS path between \c s and \c t.
+    ///
+    ///\return The length of the %DFS s---t path if there exists one,
+    ///0 otherwise.
+    ///\note Apart from the return value, d.run(s,t) is
+    ///just a shortcut of the following code.
+    ///\code
+    ///  d.init();
+    ///  d.addSource(s);
+    ///  d.start(t);
+    ///\endcode
+    int run(Node s,Node t) {
+      init();
+      addSource(s);
+      start(t);
+      return reached(t)?_stack_head+1:0;
+    }
+
     ///@}
 
@@ -666,40 +656,37 @@
     ///The result of the %DFS algorithm can be obtained using these
     ///functions.\n
-    ///Either \ref lemon::Dfs::run() "run()" or \ref lemon::Dfs::start()
-    ///"start()" must be called before using them.
+    ///Before the use of these functions,
+    ///either run() or start() must be called.
 
     ///@{
 
-    ///The DFS path to a node.
-
-    ///Returns the DFS path to a node.
-    ///
-    ///\warning \c t should be reachable from the root.
-    ///
-    ///\pre Either \ref run() or \ref start() must be called before
-    ///using this function.
-    Path path(Node t) const { return Path(*G, *_pred, t); }
-
-    ///The distance of a node from the root.
-
-    ///Returns the distance of a node from the root.
-    ///
-    ///\warning If node \c v is not reachable from the root, then
-    ///the return value of this function is undefined.
-    ///
-    ///\pre Either \ref run() or \ref start() must be called before
-    ///using this function.
+    typedef PredMapPath<Digraph, PredMap> Path;
+
+    ///Gives back the shortest path.
+
+    ///Gives back the shortest path.
+    ///\pre The \c t should be reachable from the source.
+    Path path(Node t)
+    {
+      return Path(*G, *_pred, t);
+    }
+
+    ///The distance of a node from the root(s).
+
+    ///Returns the distance of a node from the root(s).
+    ///\pre \ref run() must be called before using this function.
+    ///\warning If node \c v is unreachable from the root(s) then the return
+    ///value of this funcion is undefined.
     int dist(Node v) const { return (*_dist)[v]; }
 
-    ///Returns the 'previous arc' of the %DFS tree for a node.
-
-    ///This function returns the 'previous arc' of the %DFS tree for the
-    ///node \c v, i.e. it returns the last arc of a %DFS path from the
-    ///root to \c v. It is \c INVALID
-    ///if \c v is not reachable from the root(s) or if \c v is a root.
-    ///
-    ///The %DFS tree used here is equal to the %DFS tree used in
+    ///Returns the 'previous arc' of the %DFS tree.
+
+    ///For a node \c v it returns the 'previous arc'
+    ///of the %DFS path,
+    ///i.e. it returns the last arc of a %DFS path from the root(s) to \c
+    ///v. It is \ref INVALID
+    ///if \c v is unreachable from the root(s) or \c v is a root. The
+    ///%DFS tree used here is equal to the %DFS tree used in
     ///\ref predNode().
-    ///
     ///\pre Either \ref run() or \ref start() must be called before using
     ///this function.
@@ -708,12 +695,12 @@
     ///Returns the 'previous node' of the %DFS tree.
 
-    ///This function returns the 'previous node' of the %DFS
-    ///tree for the node \c v, i.e. it returns the last but one node
-    ///from a %DFS path from the root to \c v. It is \c INVALID
-    ///if \c v is not reachable from the root(s) or if \c v is a root.
-    ///
-    ///The %DFS tree used here is equal to the %DFS tree used in
-    ///\ref predArc().
-    ///
+    ///For a node \c v it returns the 'previous node'
+    ///of the %DFS tree,
+    ///i.e. it returns the last but one node from a %DFS path from the
+    ///root(s) to \c v.
+    ///It is INVALID if \c v is unreachable from the root(s) or
+    ///if \c v itself a root.
+    ///The %DFS tree used here is equal to the %DFS
+    ///tree used in \ref predArc().
     ///\pre Either \ref run() or \ref start() must be called before
     ///using this function.
